unit mainfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SDL_geomap, SDL_numlab, ExtCtrls;

type
  TForm1 = class(TForm)
    GM1: TGeoMap;
    Panel1: TPanel;
    NLabPixX: TNumLab;
    NLabPixY: TNumLab;
    NLabLat: TNumLab;
    NLabLong: TNumLab;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure GM1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    procedure ThreePointCalibration (ThreePoints: array of TCalQuad);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


(******************************************************************************)
procedure TForm1.ThreePointCalibration (ThreePoints: array of TCalQuad);
(******************************************************************************)

var
  i, j           : integer;
  dlat1, dlat2   : double;
  dlong1, dlong2 : double;
  dx1, dx2       : double;
  dy1, dy2       : double;

begin
GM1.CalibModel := cmBiquadraticPn;
GM1.ClearCalibData;
dlat1 := (ThreePoints[1].Latitude - ThreePoints[0].Latitude)/2;
dlat2 := (ThreePoints[2].Latitude - ThreePoints[1].Latitude)/2;
dlong1 := (ThreePoints[1].longitude - ThreePoints[0].longitude)/2;
dlong2 := (ThreePoints[2].longitude - ThreePoints[1].longitude)/2;
dx1 := (ThreePoints[1].MapX - ThreePoints[0].MapX)/2;
dx2 := (ThreePoints[2].MapX - ThreePoints[1].MapX)/2;
dy1 := (ThreePoints[1].MapY - ThreePoints[0].MapY)/2;
dy2 := (ThreePoints[2].MapY - ThreePoints[1].MapY)/2;
for i:=0 to 2 do
  for j := 0 to 2 do
    begin
    GM1.AddCalibPoint (ThreePoints[0].Latitude+i*dlat1+j*dlat2,
                       ThreePoints[0].Longitude+i*dlong1+j*dlong2,
                       round(ThreePoints[0].MapX+i*dx1+j*dx2),
                       round(ThreePoints[0].MapY+i*dy1+j*dy2));
    end;
end;


(******************************************************************************)
procedure TForm1.Button1Click(Sender: TObject);
(******************************************************************************)

(*
33.52.27S,150.49.69E   =  -33.87116667 / 150.82816667
33.55.13S,150.54.84E   =  -33.91883333 / 150.91400000
Sydney Level 3 - Bonnyrigg
*)

var
  MyCalPoints : array[1..3] of TCalQuad;

begin
GM1.MapImgFile := 'syd-3-41.jpg';

MyCalPoints[1].Latitude := -33.87116667;
MyCalPoints[1].Longitude := 150.82816667;
MyCalPoints[1].MapX := 0;
MyCalPoints[1].MapY := 0;

MyCalPoints[2].Latitude := -33.87116667;
MyCalPoints[2].Longitude := 150.91400000;
MyCalPoints[2].MapX := 1008;
MyCalPoints[2].MapY := 0;

MyCalPoints[3].Latitude := -33.91883333;
MyCalPoints[3].Longitude := 150.82816667;
MyCalPoints[3].MapX := 0;
MyCalPoints[3].MapY := 643;

ThreePointCalibration (MyCalPoints);
end;

(******************************************************************************)
procedure TForm1.GM1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
(******************************************************************************)

var
  valid : boolean;

begin
NLabPixX.Value := X+GM1.TopLeft.X;        // display mouse coordinates
NLabPixY.Value := Y+GM1.TopLeft.Y;
NLabLat.Value := GM1.CalcLatitude(X+GM1.TopLeft.X,Y+GM1.TopLeft.Y,valid);
NLabLong.Value := GM1.CalcLongitude(X+GM1.TopLeft.X,Y+GM1.TopLeft.Y,valid);
end;

end.
